function result = check_steady_state(m_prev, m_cur, m0, tol_level)
% result = check_steady_state(m_prev, m_cur, m0, tol_level)
%
% Check if steady state is reached with given tolerance level, code
%

%%%%%%%%%%%%%%%%%%%%%%%%%%
%   Ye Gu, Ives Levesque, Nikola Stikov (2011)
%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%
% modified from Ives' code to make sure it can be satisfied even if m0 has zero
% x-y components.
%%%%%%%%%%%%%%%%%%%%%%

if (size(m_prev) ~= size(m_cur)) | (size(m_cur) ~= size(m0))
  error('Input arrays do not match.');
end

array_size = sum(sum(ones(size(m0))));
tol_matrix = tol_level*m_prev;

diff = m_cur - m_prev;

% return boolean result based on comparison of entire magnetization vector
result = sum(sum(abs(diff) <= abs(tol_matrix))) == array_size;
