function g_gauss = gaussianLineshape(delta, T_2r)
% function g_gauss = gaussianLineshape(delta, T_2r)
%
%   delta in Hz, T_2r in seconds
%   returns the lineshape amplitude of a Gaussian pool of given T2r, at the indicated frequency
%
%   scaled such that Rrf = pi*(omega1^2)*line
%
%------------------------

%%%%%%%%%%%%%%%%%%%%%%%%%%
%   Ye Gu, Ives Levesque, Nikola Stikov (2011)
%%%%%%%%%%%%%%%%%%%%%%%%%%

g_gauss = sqrt(1/(2*pi))*T_2r*exp(-((2*pi*delta*T_2r).^2)/2);
