function plot_fit(offsets, omega_cwpe, lineshape, measurements, fit_result)
% function plot_fit(offsets, omega_cwpe, lineshape, measurements, fit_result)
%
%	a function to plot Z-spectrum data and resulting fit
%	from CWPE approximation of two-pool model
%

%
%	Ives Levesque, 2011
%	ives@stanford.edu
%
%------------------------------------------------------------------------------

figure(1)

% plot data
h = semilogx(offsets,measurements,'o')
set(h, 'LineWidth',1.5)

% add more offsets for plot of model fit
more_offsets = logspace(log10(.5*min(offsets)),log10(1.5*max(offsets)),20);

% compute theoretical signal and add to plit
fit_s = cw_model(fit_result, omega_cwpe, more_offsets, lineshape );

hold on
h = semilogx(more_offsets,fit_s,'k-')
set(h, 'LineWidth',1.5)
hold off

grid
set(gca,'FontSize',14)
xlabel('Offset frequency (Hz)')
ylabel('Normalized signal')
