function a = getFreePrecessionMatrix(num_pools, t1, t2, k_for, k_rev);
%
% function a = getFreePrecessionMatrix(num_pools, t1, t2, k_for, k_rev);
%
% Function returns the 2-pool Bloch matrix "A" for free precession
%	such that dM/dT = A*M +B*M0, where B0 is the appropriate R1 relaxation vector
%
% assumes no exchange of XY magnetization between solid-liquid pool pair   
%

%
%	Ives Levesque, 2011
%
%---------------------------------------------------------------------------------------------------------------------------


a = getCWSatMatrix(num_pools, t1, t2, k_for, k_rev, 0, 0, 0);