function showQmtSimResult()
%
% showQmtSimResult()
%
%   a function to plot simulated QMT data and fit with RP model
%


%cd matlab/bloch_sim/

%---------------------------------------------------------------------------
%---------------------------------------------------------------------------
%	load and plot Bloch simulation results



me_model = 'wm';
plot_analytical = 0;
my_show_fit = 1;

load(['sim_results.mat'])

num_nosats = 0;
for k = 1:length(expt)
    mt_angles(k) = expt(k).sat_flips;
    offsets(k,:) = expt(k).offset(1:end-1);
    sim_result(k).mag_signal(1:end-1)./sim_result(k).mag_signal(end);
    norm_signal(k,:) = sim_result(k).mag_signal(1:end-1)./sim_result(k).mag_signal(end);
end

t_mt = expt(1).sat_dur;
tr = expt(1).tr;

figure(2)
hold on

size(norm_signal)

for k = 1:length(expt)-num_nosats
    semilogx(offsets(k,:), squeeze(norm_signal(k,:)),'o')
end

grid
set(gca,'XScale','log')
xlabel('offset frequency (Hz)')
ylabel('signal(a.u.)')
title('simulated signal')

hold off


% compute theoretical R1obs on the fly instead
b = sum(1./model_system.t1) + model_system.k_for + model_system.k_rev;
c = prod(1./model_system.t1) + model_system.k_rev/model_system.t1(1) + model_system.k_for/model_system.t1(2);

R1obs = 0.5 * ( b - sqrt( b^2 - 4*c ) )
t1obs = 1/R1obs;

%p = fit_cw_model(mt_angles, offsets, t_mt, tr, model_system.lineshape_type, norm_signal, t1obs, [p0, r1r, fitmask])
p = fit_cw_model(mt_angles, offsets(1,:), t_mt, tr, model_system.lineshape_type, norm_signal, t1obs)


