function [W_alpha,W_Trf] = computeW(alphas,Trfs,fixTrf,fixAngle,G)

W_alpha=[];
W_Trf=[];

% find W's for varying alpha

if(fixTrf~=0)
    x=0:0.0001e-4:fixTrf;
    y=abs(sinc(4 / fixTrf * (x - fixTrf/2)));
    tempIntegral = trapz(x,y);
    amp = alphas*pi/180/(4258 * 2 * pi * tempIntegral);
    W_alpha = 0 * alphas;
    clear tempIntegral;

    for i = 1:length(alphas)
        x=0:0.0001e-4:fixTrf;
        y=pi/(fixTrf) * G *(4258 *2 * pi*amp(i)*abs(sinc(4/fixTrf * (x - fixTrf/2)))).^2;
        W_alpha(i)=trapz(x, y);
        clear x y
    end
end

% find W's for varying Trf

if(fixAngle~=0)
    W_Trf = 0 * Trfs;
    for i = 1:length(Trfs)
        x=0:0.0001e-4:Trfs(i);
        z=abs(sinc(4 / Trfs(i) * (x - Trfs(i)/2)));
        tempIntegral = trapz(x,z);
        ampT = fixAngle*pi/180/(4258 * 2 * pi * tempIntegral);
        y=pi/(Trfs(i)) * G *(4258 * 2 * pi * ampT * abs(sinc(4/Trfs(i) * (x - Trfs(i)/2)))).^2;
        W_Trf(i)=trapz(x,y);
        clear x y z
    end
end

% Reference: M. Gloor, K. Scheffler, and O. Bieri. "Quantitative
% Magnetization Transfer Imaging Using Balanced SSFP", Magnetic Resonance
% in Medicine 60:691–700 (2008)