function g_lorentz = lorentzianLineshape(delta, T_2r)
% function g_lorentz = lorentzianLineshape(delta, T_2r)
%
%   returns the lineshape amplitude of a Lorentzian pool of given T2, at the indicated frequency
%
%   scaled such that Rrf = pi*(omega1^2)*line
%
%------------------------

g_lorentz = (T_2r/pi)./(1+(2*pi*delta*T_2r).^2);
