function sse=myfit(params,alphas, M_alpha, W_alpha, Trfs, M_Trf, W_Trf, TR_array, fixAlpha, fixTrf, fixTR, param_array, mask)

%Function which returns the sum of (error differences)^2


%Try new parameters
p = param_array;
p(mask == 0) = params;


firstFit=zeros(1,length(alphas));
secondFit=zeros(1,length(Trfs));

%Find the analytical solution for different parameters
if ~isempty(alphas)
    for i=1:length(alphas)
        firstFit(i)=solution(alphas(i), fixTR, fixTrf, p(1), p(2), p(3), p(4), W_alpha(i));
    end
end


if ~isempty(Trfs)
    for i=1:length(Trfs)
        secondFit(i) = solution(fixAlpha,TR_array(i),Trfs(i), p(1), p(2), p(3), p(4), W_Trf(i));
    end
end

%sum the differences squared
if isempty(alphas)
    sse1 = 0;
else
    Error_Vector1=firstFit - M_alpha;
    sse1 = Error_Vector1*Error_Vector1';
end

if isempty(Trfs)
    sse2 = 0;
else
    Error_Vector2=secondFit - M_Trf;
    sse2 = Error_Vector2*Error_Vector2';
end

sse = sse1 + sse2;