function yprime=odes_temp(t,y)

%%%%%%%%%%%%%%%%%%%%%
%ODEs during relaxation (without pulse excitation)

load('./SimTempData/SimulationParams.mat');

omega=0;

M_0r=F;
R_1f=1/(T_1f);
R_1r=1;
R_2f=1/(T_2f);
K_r=k_f/F;
W=pi*G*omega^2;

yprime=zeros(4,1);
yprime(1)=-R_2f*y(1);
yprime(2)=-R_2f*y(2)+omega*y(3);
yprime(3)=R_1f*(M_0f-y(3))-k_f*y(3)+K_r*y(4)-omega*y(2);
yprime(4)=R_1r*(M_0r-y(4))+k_f*y(3)-K_r*y(4)-W*y(4);

% Reference: M. Gloor, K. Scheffler, and O. Bieri. "Quantitative
% Magnetization Transfer Imaging Using Balanced SSFP", Magnetic Resonance
% in Medicine 60:691–700 (2008)