function varargout = fitting_gui(varargin)
% FITTING_GUI M-file for fitting_gui.fig
%      FITTING_GUI, by itself, creates a new FITTING_GUI or raises the existing
%      singleton*.
%
%      H = FITTING_GUI returns the handle to a new FITTING_GUI or the handle to
%      the existing singleton*.
%
%      FITTING_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in FITTING_GUI.M with the given input arguments.
%
%      FITTING_GUI('Property','Value',...) creates a new FITTING_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before fitting_gui_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to fitting_gui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help fitting_gui

% Last Modified by GUIDE v2.5 18-Aug-2011 23:00:07

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @fitting_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @fitting_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before fitting_gui is made visible.
function fitting_gui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to fitting_gui (see VARARGIN)

% Choose default command line output for fitting_gui
handles.output = hObject;

% UIWAIT makes fitting_gui wait for user response (see UIRESUME)
% uiwait(handles.figure1);

%Y-Y

% Initialize variables used across the GUI and save them in temporary files
% for later usage, load and set default values.
alphas_array=[];
Trfs_array=[];
legend_array=[];
count=1;
save('./FitTempData/arrays.mat', 'count', 'Trfs_array', 'alphas_array','legend_array');
load('./Parameters/DefaultParams.mat');

set(handles.F_num,'String',num2str(F));
set(handles.k_f_num,'String',num2str(k_f));
set(handles.T1f_num,'String',num2str(T_1f));
set(handles.T2f_num,'String',num2str(T_2f));
set(handles.T2r_num,'String',num2str(T_2r));
set(handles.F_slider,'Value',F);
set(handles.k_f_slider,'Value',k_f);
set(handles.T1f_slider,'Value',T_1f);
set(handles.T2f_slider,'Value',T_2f);
set(handles.T2r_slider,'Value',T_2r);

set(handles.F_num,'Enable','off');
set(handles.k_f_num,'Enable','off');
set(handles.T1f_num,'Enable','off');
set(handles.T2f_num,'Enable','off');
set(handles.T2r_num,'Enable','off');
set(handles.F_slider,'Enable','off');
set(handles.k_f_slider,'Enable','off');
set(handles.T1f_slider,'Enable','off');
set(handles.T2f_slider,'Enable','off');
set(handles.T2r_slider,'Enable','off');


set(handles.Alpha_table,'Data',cell(1,5));
set(handles.Alpha_table,'ColumnFormat',{'numeric','numeric','numeric','numeric','logical'});
set(handles.Alpha_table,'ColumnEditable',[false false false false true]);
set(handles.Alpha_table,'UserData',[]);
set(handles.Trf_table,'Data',cell(1,5));
set(handles.Trf_table,'ColumnFormat',{'numeric','numeric','numeric','numeric','logical'});
set(handles.Trf_table,'ColumnEditable',[false false false false true]);
set(handles.Trf_table,'UserData',[]);

set(handles.Fit_button,'UserData',[0 0 0 0]');

set(handles.G_fixed_val,'String',num2str(G));
set(handles.fix_G,'Value',get(handles.fix_G,'Max'));
set(handles.Gaussian,'Value',get(handles.Gaussian,'Min'));
set(handles.Lorentzian,'Value',get(handles.Lorentzian,'Min'));
set(handles.SuperLorentzian,'Value',get(handles.SuperLorentzian,'Min'));

set(handles.legendOn,'Value',get(handles.legendOn,'Min'));
set(handles.gridOn,'Value',get(handles.gridOn,'Min'));

guidata(hObject, handles);
% Y-Y


% --- Outputs from this function are returned to the command line.
function varargout = fitting_gui_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on slider movement.
function F_slider_Callback(hObject, eventdata, handles)
% hObject    handle to F_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

%Y-Y
% Sync the values of slider and box
temp=get(hObject,'Value');
set(handles.F_num,'String',num2str(temp));
guidata(hObject, handles);
%Y-Y

% --- Executes during object creation, after setting all properties.
function F_slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to F_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function k_f_slider_Callback(hObject, eventdata, handles)
% hObject    handle to text (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

%Y-Y
% Sync the values of slider and box
temp=get(hObject,'Value');
set(handles.k_f_num,'String',num2str(temp));
guidata(hObject, handles);
%Y-Y

% --- Executes during object creation, after setting all properties.
function k_f_slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to F_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

% --- Executes on slider movement.
function T1f_slider_Callback(hObject, eventdata, handles)
% hObject    handle to T1f_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

%Y-Y
% Sync the values of slider and box
temp=get(hObject,'Value');
set(handles.T1f_num,'String',num2str(temp));
guidata(hObject, handles);
%Y-Y

% --- Executes during object creation, after setting all properties.
function T1f_slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to T1f_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

% --- Executes on slider movement.
function T2f_slider_Callback(hObject, eventdata, handles)
% hObject    handle to text (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

%Y-Y
% Sync the values of slider and box
temp=get(hObject,'Value');
set(handles.T2f_num,'String',num2str(temp));
guidata(hObject, handles);
%Y-Y


% --- Executes during object creation, after setting all properties.
function T2f_slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

% --- Executes on slider movement.
function T2r_slider_Callback(hObject, eventdata, handles)
% hObject    handle to T2r_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

%Y-Y
% Sync the values of slider and box
temp=get(hObject,'Value');
set(handles.T2r_num,'String',num2str(temp));
guidata(hObject, handles);
%Y-Y

% --- Executes during object creation, after setting all properties.
function T2r_slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to T2r_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

function F_num_Callback(hObject, eventdata, handles)
% hObject    handle to F_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of F_num as text
%        str2double(get(hObject,'String')) returns contents of F_num as a double

%Y-Y
% Sync the values of slider and box
temp=min(str2num(get(hObject,'String')),0.2);
set(handles.F_slider,'Value',(temp));
set(handles.F_num,'String',num2str(temp));
guidata(hObject, handles);
%Y-Y

% --- Executes during object creation, after setting all properties.
function F_num_CreateFcn(hObject, eventdata, handles)
% hObject    handle to F_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function k_f_num_Callback(hObject, eventdata, handles)
% hObject    handle to k_f_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of k_f_num as text
%        str2double(get(hObject,'String')) returns contents of k_f_num as a double

%Y-Y
% Sync the values of slider and box
temp=min(str2num(get(hObject,'String')),20);
set(handles.k_f_slider,'Value',(temp));
set(handles.k_f_num,'String',num2str(temp));
guidata(hObject, handles);
%Y-Y

% --- Executes during object creation, after setting all properties.
function k_f_num_CreateFcn(hObject, eventdata, handles)
% hObject    handle to k_f_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function T1f_num_Callback(hObject, eventdata, handles)
% hObject    handle to T1f_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of T1f_num as text
%        str2double(get(hObject,'String')) returns contents of T1f_num as a double

%Y-Y
% Sync the values of slider and box
temp=min(str2num(get(hObject,'String')),10);
set(handles.T1f_slider,'Value',(temp));
set(handles.T1f_num,'String',num2str(temp));
guidata(hObject, handles);
%Y-Y

% --- Executes during object creation, after setting all properties.
function T1f_num_CreateFcn(hObject, eventdata, handles)
% hObject    handle to T1f_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function T2f_num_Callback(hObject, eventdata, handles)
% hObject    handle to T2f_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of T2f_num as text
%        str2double(get(hObject,'String')) returns contents of T2f_num as a double

%Y-Y
% Sync the values of slider and box
temp=min(str2num(get(hObject,'String')),0.1);
set(handles.T2f_slider,'Value',(temp));
set(handles.T2f_num,'String',num2str(temp));
guidata(hObject, handles);
%Y-Y


% --- Executes during object creation, after setting all properties.
function T2f_num_CreateFcn(hObject, eventdata, handles)
% hObject    handle to T2f_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function T2r_num_Callback(hObject, eventdata, handles)
% hObject    handle to T2r_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of T2r_num as text
%        str2double(get(hObject,'String')) returns contents of T2r_num as a double

%Y-Y
% Sync the values of slider and box
temp=min(str2num(get(hObject,'String')),0.0001);
set(handles.T2r_slider,'Value',(temp));
set(handles.T2r_num,'String',num2str(temp));
guidata(hObject, handles);
%Y-Y

% --- Executes during object creation, after setting all properties.
function T2r_num_CreateFcn(hObject, eventdata, handles)
% hObject    handle to T2r_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function G_fixed_val_Callback(hObject, eventdata, handles)
% hObject    handle to G_fixed_val (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of G_fixed_val as text
%        str2double(get(hObject,'String')) returns contents of G_fixed_val as a double


% --- Executes during object creation, after setting all properties.
function G_fixed_val_CreateFcn(hObject, eventdata, handles)
% hObject    handle to G_fixed_val (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes when selected object is changed in lineshape.
function lineshape_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in lineshape 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)

%Y-Y
% Y-Y 
% Dummy function for button change to work properly.
lineshape=(get(hObject,'String'));
guidata(hObject, handles);
%Y-Y

% --- Executes on button press in Load_Button.
function Load_Button_Callback(hObject, eventdata, handles)
% hObject    handle to Load_Button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Y-Y
% Load Parameters file defined by user, default parameters are loaded
% in case user fails to load right file, sets corresponding fields
G =1.4e-5;
load('./Parameters/DefaultParams.mat');
cd Parameters
uiload
cd ..

set(handles.F_num,'String',num2str(F));
set(handles.k_f_num,'String',num2str(k_f));
set(handles.T1f_num,'String',num2str(T_1f));
set(handles.T2f_num,'String',num2str(T_2f));
set(handles.T2r_num,'String',num2str(T_2r));
set(handles.F_slider,'Value',F);
set(handles.k_f_slider,'Value',k_f);
set(handles.T1f_slider,'Value',T_1f);
set(handles.T2f_slider,'Value',T_2f);
set(handles.T2r_slider,'Value',T_2r);

set(handles.G_fixed_val,'String',num2str(G));
set(handles.fix_G,'Value',get(handles.fix_G,'Max'));
set(handles.Gaussian,'Value',get(handles.Gaussian,'Min'));
set(handles.Lorentzian,'Value',get(handles.Lorentzian,'Min'));
set(handles.SuperLorentzian,'Value',get(handles.SuperLorentzian,'Min'));

guidata(hObject, handles);
% Y-Y


% --- Executes on button press in Save_Button.
function Save_Button_Callback(hObject, eventdata, handles)
% hObject    handle to Save_Button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Y-Y

% Save current values of parameters (fit results) into a .mat file 

F=str2num(get(handles.F_num,'String'));
T_2f=str2num(get(handles.T2f_num,'String'));
k_f=str2num(get(handles.k_f_num,'String'));
T_1f=str2num(get(handles.T1f_num,'String'));
T_2r=str2num(get(handles.T2r_num,'String'));

uisave({'F','k_f','T_1f','T_2f','T_2r'},'./FitResults/LastSetFitResults.mat');
guidata(hObject, handles);
% Y-Y

% --- Executes on button press in legendOn.
function legendOn_Callback(hObject, eventdata, handles)
% hObject    handle to legendOn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of legendOn

% Y-Y
% show/hide legend
load('./FitTempData/arrays.mat');
legend(handles.alpha_plot,'off');
if get(hObject,'Value') == get(hObject,'Max')
    h1 = legend(handles.alpha_plot,legend_array,'Location','South');
    set(h1,'FontSize',9);
end
guidata(hObject, handles);
% Y-Y


% --- Executes on button press in gridOn.
function gridOn_Callback(hObject, eventdata, handles)
% hObject    handle to gridOn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of gridOn

% Y-Y
% show/hide grid
if get(hObject,'Value') == get(hObject,'Max')
    grid(handles.alpha_plot,'on');
    grid(handles.Trf_plot,'on');
else
    grid(handles.alpha_plot,'off');
    grid(handles.Trf_plot,'off');
end

guidata(hObject, handles);
% Y-Y


% --- Executes on button press in F_checkbox.
function F_checkbox_Callback(hObject, eventdata, handles)
% hObject    handle to F_checkbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of F_checkbox

% Y-Y

% Choose whether parameter is to be fixed manually or to be fitted. 
% If checked, enables slider and numerical box, set parameter's associated
% mask value to the value set in the numerical box.
% If unchecked, disables slider and numerical box, set parameters
% associated mask value to 0.

temp = get(handles.Fit_button,'UserData');


if get(hObject,'Value') == get(hObject,'Min')
    set(handles.F_num,'Enable','off');
    set(handles.F_slider,'Enable','off');
    temp(1) = 0;
else
    set(handles.F_num,'Enable','on');
    set(handles.F_slider,'Enable','on');
    temp(1) = str2num(get(handles.F_num,'String'));
end

set(handles.Fit_button,'UserData',temp);

guidata(hObject, handles);
% Y-Y


% --- Executes on button press in k_f_checkbox.
function k_f_checkbox_Callback(hObject, eventdata, handles)
% hObject    handle to k_f_checkbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of k_f_checkbox

% Y-Y

% Choose whether parameter is to be fixed manually or to be fitted. 
% If checked, enables slider and numerical box, set parameter's associated
% mask value to the value set in the numerical box.
% If unchecked, disables slider and numerical box, set parameters
% associated mask value to 0.
temp = get(handles.Fit_button,'UserData');


if get(hObject,'Value') == get(hObject,'Min')
    set(handles.k_f_num,'Enable','off');
    set(handles.k_f_slider,'Enable','off');
    temp(2) = 0;
else
    set(handles.k_f_num,'Enable','on');
    set(handles.k_f_slider,'Enable','on');
    temp(2) = str2num(get(handles.k_f_num,'String'));
end

set(handles.Fit_button,'UserData',temp);

guidata(hObject, handles);
% Y-Y


% --- Executes on button press in T1f_checkbox.
function T1f_checkbox_Callback(hObject, eventdata, handles)
% hObject    handle to T1f_checkbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of T1f_checkbox

% Y-Y
% Choose whether parameter is to be fixed manually or to be fitted. 
% If checked, enables slider and numerical box, set parameter's associated
% mask value to the value set in the numerical box.
% If unchecked, disables slider and numerical box, set parameters
% associated mask value to 0.
temp = get(handles.Fit_button,'UserData');


if get(hObject,'Value') == get(hObject,'Min')
    set(handles.T1f_num,'Enable','off');
    set(handles.T1f_slider,'Enable','off');
    temp(3) = 0;
else
    set(handles.T1f_num,'Enable','on');
    set(handles.T1f_slider,'Enable','on');
    temp(3) = str2num(get(handles.T1f_num,'String'));
end

set(handles.Fit_button,'UserData',temp);

guidata(hObject, handles);
% Y-Y

% --- Executes on button press in T2f_checkbox.
function T2f_checkbox_Callback(hObject, eventdata, handles)
% hObject    handle to T2f_checkbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of T2f_checkbox

% Y-Y
% Choose whether parameter is to be fixed manually or to be fitted. 
% If checked, enables slider and numerical box, set parameter's associated
% mask value to the value set in the numerical box.
% If unchecked, disables slider and numerical box, set parameters
% associated mask value to 0.
temp = get(handles.Fit_button,'UserData');


if get(hObject,'Value') == get(hObject,'Min')
    set(handles.T2f_num,'Enable','off');
    set(handles.T2f_slider,'Enable','off');
    temp(4) = 0;
else
    set(handles.T2f_num,'Enable','on');
    set(handles.T2f_slider,'Enable','on');
    temp(4) = str2num(get(handles.T2f_num,'String'));
end

set(handles.Fit_button,'UserData',temp);

guidata(hObject, handles);
% Y-Y


% --- Executes on button press in LoadAlpha_button.
function LoadAlpha_button_Callback(hObject, eventdata, handles)
% hObject    handle to LoadAlpha_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Y-Y
% Button to load varying flip angle protocol file, list the protocols in
% varying flip angle protocol table, and plot data points in varying flip
% angle axis

% Allow user to load file, load Demo file in case user fails to load proper
% file
load('./SimulatedData/VaryingAlpha_Demo2.mat');
cd SimulatedData
uiload
cd ..

% load temporary variables array file 
load('./FitTempData/arrays.mat');

% initialize legend entry
legend_array = 'Data';

% save temporary variables array file with updated legend array
save('./FitTempData/arrays.mat', 'count', 'Trfs_array', 'alphas_array','legend_array');

% create table data matrix (of cells) with loaded data
tableData = cell(length(alphas),5);
tableData(:,1) = num2cell(alphas');
tableData(:,2) = {fixTrf};
tableData(:,3) = {fixTR};
tableData(:,4) = num2cell(M_alpha');
tableData(:,5) = {true};

% Set table data and properties
set(handles.Alpha_table,'Data',tableData);
set(handles.Alpha_table,'ColumnFormat',{'numeric','numeric','numeric','numeric','logical'});
set(handles.Alpha_table,'ColumnEditable',[false false false false true]);

% Store all data as 'UserData' for fit_button to load
data = [cell2mat(tableData(:,1:4)) cell2mat(tableData(:,5))];
set(handles.Alpha_table,'UserData',data);

% Plot loaded data points in the corresponding axis
plot(handles.alpha_plot, data(:,1), data(:,4),'ob');
xlabel(handles.alpha_plot, 'Flip angle (degree)','FontSize',9);
ylabel(handles.alpha_plot, '|M_{xy}| (normalized)','FontSize',9);
axis(handles.alpha_plot, [0 max(data(:,1))*1.1 0 max(data(:,4))*1.1]);

guidata(hObject, handles);
% Y-Y

% --- Executes on button press in LoadTrf_button.
function LoadTrf_button_Callback(hObject, eventdata, handles)
% hObject    handle to LoadTrf_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Y-Y

% Allow user to load file, load Demo file in case user fails to load proper
% file
load('./SimulatedData/VaryingTrf_Demo2.mat');
cd SimulatedData
uiload
cd ..

% load temporary variables array file 
load('./FitTempData/arrays.mat');

% initialize legend entry
legend_array = 'Data';

% save temporary variables array file with updated legend array
save('./FitTempData/arrays.mat', 'count', 'Trfs_array', 'alphas_array','legend_array');

% create table data matrix (of cells) with loaded data
tableData = cell(length(Trfs),5);
tableData(:,1) = {fixAlpha};
tableData(:,2) = num2cell(Trfs');
tableData(:,3) = num2cell(TR_array');
tableData(:,4) = num2cell(M_Trf');
tableData(:,5) = {true};

% Set table data and properties
set(handles.Trf_table,'Data',tableData);
set(handles.Trf_table,'ColumnFormat',{'numeric','numeric','numeric','numeric','logical'});
set(handles.Trf_table,'ColumnEditable',[false false false false true]);

% Store all data as 'UserData' for fit_button to load
data = [cell2mat(tableData(:,1:4)) cell2mat(tableData(:,5))];
set(handles.Trf_table,'UserData',data);

% Plot loaded data points in the corresponding axis
plot(handles.Trf_plot, data(:,2), data(:,4),'ob');
xlabel(handles.Trf_plot, 'T_{rf} (s)','FontSize',9);
ylabel(handles.Trf_plot, '|M_{xy}| (normalized)','FontSize',9);
axis(handles.Trf_plot, [0 max(data(:,2))*1.1 0 max(data(:,4))*1.1]);


guidata(hObject, handles);
% Y-Y

% --- Executes when entered data in editable cell(s) in Alpha_table.
function Alpha_table_CellEditCallback(hObject, eventdata, handles)
% hObject    handle to Alpha_table (see GCBO)
% eventdata  structure with the following fields (see UITABLE)
%	Indices: row and column indices of the cell(s) edited
%	PreviousData: previous data for the cell(s) edited
%	EditData: string(s) entered by the user
%	NewData: EditData or its converted form set on the Data property. Empty if Data was not changed
%	Error: error string when failed to convert EditData to appropriate value for Data
% handles    structure with handles and user data (see GUIDATA)

% Y-Y

% Allows user to select points of interest, store only points which
% checkbox checked to be fitted and display only checked points in axes

% Get all data points and convert to matrix
tableData = get(handles.Alpha_table,'Data');
data = [cell2mat(tableData(:,1:4)) cell2mat(tableData(:,5))];

% Create matrix with selected data only, store data as 'UserData' for later
% usage bu fit button, and refresh table properties
selectedData = data((data(:,5)==1),:);
set(handles.Alpha_table,'ColumnFormat',{'numeric','numeric','numeric','numeric','logical'});
set(handles.Alpha_table,'ColumnEditable',[false false false false true]);
set(handles.Alpha_table,'UserData',selectedData);

% Update plots in the corresponding axes

% Load temporary variables array file
load('./FitTempData/arrays.mat');

% Plot either selected data points only or selected data points with 
% existing fits according to the case
if isempty(alphas_array)
    plot(handles.alpha_plot,selectedData(:,1), selectedData(:,4),'ob');
    xlabel(handles.alpha_plot, 'Flip angle (degree)','FontSize',9);
    ylabel(handles.alpha_plot, '|M_{xy}| (normalized)','FontSize',9);
    axis(handles.alpha_plot, [0 max(data(:,1))*1.1 0 max(data(:,4))*1.1]);
else
    plot(handles.alpha_plot, selectedData(:,1), selectedData(:,4), 'ob', alphas_array(:,:,1), alphas_array(:,:,2), '-');
    xlabel(handles.alpha_plot, 'Flip angle (degree)','FontSize',9);
    ylabel(handles.alpha_plot, '|M_{xy}| (normalized)','FontSize',9);
    axis(handles.alpha_plot, [0 max(max(max(alphas_array(:,:,1))),max(selectedData(:,1)))*1.1 0 max(max(max(alphas_array(:,:,2))), max(selectedData(:,4)))*1.1]);
end

% Turn legend on if checkbox checked
if (get(handles.legendOn,'Value') == get(handles.legendOn,'Max'))    
    h1 = legend(handles.alpha_plot,legend_array,'Location','South');
    set(h1,'FontSize',9);
end

% Turn grid on if checkbox checked
if get(handles.gridOn,'Value') == get(handles.gridOn,'Max')
    grid(handles.alpha_plot,'on');
end

guidata(hObject, handles);

% Y-Y

% --- Executes when entered data in editable cell(s) in Trf_table.
function Trf_table_CellEditCallback(hObject, eventdata, handles)
% hObject    handle to Trf_table (see GCBO)
% eventdata  structure with the following fields (see UITABLE)
%	Indices: row and column indices of the cell(s) edited
%	PreviousData: previous data for the cell(s) edited
%	EditData: string(s) entered by the user
%	NewData: EditData or its converted form set on the Data property. Empty if Data was not changed
%	Error: error string when failed to convert EditData to appropriate value for Data
% handles    structure with hanadles and user data (see GUIDATA)

% Y-Y

% Allows user to select points of interest, store only points which
% checkbox checked to be fitted and display only checked points in axes

% Get all data points and convert to matrix
tableData = get(handles.Trf_table,'Data');
data = [cell2mat(tableData(:,1:4)) cell2mat(tableData(:,5))];

% Create matrix with selected data only, store data as 'UserData' for later
% usage bu fit button, and refresh table properties
selectedData = data((data(:,5)==1),:);
set(handles.Trf_table,'ColumnFormat',{'numeric','numeric','numeric','numeric','logical'});
set(handles.Trf_table,'ColumnEditable',[false false false false true]);
set(handles.Trf_table,'UserData',selectedData);

% Update plots in the corresponding axes

% Load temporary variables array file
load('./FitTempData/arrays.mat');

% Plot either selected data points only or selected data points with 
% existing fits according to the case
if isempty(Trfs_array)
    plot(handles.Trf_plot,selectedData(:,2), selectedData(:,4),'ob');
    xlabel(handles.Trf_plot, 'T_{rf} (s)','FontSize',9);
    ylabel(handles.Trf_plot, '|M_{xy}| (normalized)','FontSize',9);
    axis(handles.Trf_plot, [0 max(data(:,2))*1.1 0 max(data(:,4))*1.1]);
else
    plot(handles.Trf_plot, selectedData(:,2), selectedData(:,4),'ob', Trfs_array(:,:,1), Trfs_array(:,:,2),'-');
    xlabel(handles.Trf_plot, 'T_{rf} (s)','FontSize',9);
    ylabel(handles.Trf_plot, '|M_{xy}| (normalized)','FontSize',9);
    axis(handles.Trf_plot, [0 max(max(max(Trfs_array(:,:,1))),max(selectedData(:,2)))*1.1 0 max(max(max(Trfs_array(:,:,2))), max(selectedData(:,4)))*1.1]);
end

% Turn legend on if checkbox checked
if (get(handles.legendOn,'Value') == get(handles.legendOn,'Max'))
h1 = legend(handles.alpha_plot,legend_array,'Location','South');
set(h1,'FontSize',9);
end

% Turn grid on if checkbox checked
if get(handles.gridOn,'Value') == get(handles.gridOn,'Max')
    grid(handles.Trf_plot,'on');
end

guidata(hObject, handles);
% Y-Y


% --- Executes on button press in Clear_button.
function Clear_button_Callback(hObject, eventdata, handles)
% hObject    handle to Clear_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Y-Y
% Re-initialize parameters, wipe temporary files and clear fitted curves
% plots, does not reset the protocol data table and leaves data points
% plotted
alphas_array=[];
Trfs_array=[];
legend_array=[];
count=1;
save('./FitTempData/arrays.mat', 'count', 'Trfs_array', 'alphas_array','legend_array');
load('./Parameters/DefaultParams.mat');

set(handles.F_num,'String',num2str(F));
set(handles.k_f_num,'String',num2str(k_f));
set(handles.T1f_num,'String',num2str(T_1f));
set(handles.T2f_num,'String',num2str(T_2f));
set(handles.T2r_num,'String',num2str(T_2r));
set(handles.F_slider,'Value',F);
set(handles.k_f_slider,'Value',k_f);
set(handles.T1f_slider,'Value',T_1f);
set(handles.T2f_slider,'Value',T_2f);
set(handles.T2r_slider,'Value',T_2r);

set(handles.F_num,'Enable','off');
set(handles.k_f_num,'Enable','off');
set(handles.T1f_num,'Enable','off');
set(handles.T2f_num,'Enable','off');
set(handles.T2r_num,'Enable','off');
set(handles.F_slider,'Enable','off');
set(handles.k_f_slider,'Enable','off');
set(handles.T1f_slider,'Enable','off');
set(handles.T2f_slider,'Enable','off');
set(handles.T2r_slider,'Enable','off');

set(handles.F_checkbox,'Value',get(handles.F_checkbox,'Min'));
set(handles.k_f_checkbox,'Value',get(handles.k_f_checkbox,'Min'));
set(handles.T1f_checkbox,'Value',get(handles.T1f_checkbox,'Min'));
set(handles.T2f_checkbox,'Value',get(handles.T2f_checkbox,'Min'));

set(handles.Fit_button,'UserData',[0 0 0 0]');

set(handles.G_fixed_val,'String',num2str(G));
set(handles.fix_G,'Value',get(handles.fix_G,'Max'));
set(handles.Gaussian,'Value',get(handles.Gaussian,'Min'));
set(handles.Lorentzian,'Value',get(handles.Lorentzian,'Min'));
set(handles.SuperLorentzian,'Value',get(handles.SuperLorentzian,'Min'));

load('./FitTempData/arrays.mat');

tableData = get(handles.Alpha_table,'Data');
data = [cell2mat(tableData(:,1:4)) cell2mat(tableData(:,5))];
selectedData = data((data(:,5)==1),:);

plot(handles.alpha_plot,selectedData(:,1), selectedData(:,4),'ob');
xlabel(handles.alpha_plot, 'Flip angle (degree)','FontSize',9);
ylabel(handles.alpha_plot, '|M_{xy}| (normalized)','FontSize',9);
axis(handles.alpha_plot, [0 max(data(:,1))*1.1 0 max(data(:,4))*1.1]);

clear tableData

tableData = get(handles.Trf_table,'Data');
data = [cell2mat(tableData(:,1:4)) cell2mat(tableData(:,5))];
selectedData = data((data(:,5)==1),:);

plot(handles.Trf_plot,selectedData(:,2), selectedData(:,4),'ob');
xlabel(handles.Trf_plot, 'T_{rf} (s)','FontSize',9);
ylabel(handles.Trf_plot, '|M_{xy}| (normalized)','FontSize',9);
axis(handles.Trf_plot, [0 max(data(:,2))*1.1 0 max(data(:,4))*1.1]);

if (get(handles.legendOn,'Value') == get(handles.legendOn,'Max'))
h1 = legend(handles.alpha_plot,legend_array,'Location','South');
set(h1,'FontSize',9);
end

if get(handles.gridOn,'Value') == get(handles.gridOn,'Max')
    grid(handles.alpha_plot,'on');
    grid(handles.Trf_plot,'on');
end

guidata(hObject, handles);

% Y-Y

% --- Executes on button press in Fit_button.
function Fit_button_Callback(hObject, eventdata, handles)
% hObject    handle to Fit_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%Y-Y

% Simultaneously fit for parameters with checkboxes unchecked (set to be
% fitted) to selected varying alpha points and selected varying Trf
% points

% Get current values of parameter to be used either as fixed value or
% starting value for fit
F=str2num(get(handles.F_num,'String'));
T_2f=str2num(get(handles.T2f_num,'String'));
k_f=str2num(get(handles.k_f_num,'String'));
T_1f=str2num(get(handles.T1f_num,'String'));
T_2r=str2num(get(handles.T2r_num,'String'));
M_0f=1;

if (get(handles.fix_G,'Value') == get(handles.fix_G,'Max'))
	G=str2num(get(handles.G_fixed_val, 'String'));
end

if (get(handles.Gaussian,'Value') == get(handles.Gaussian,'Max'))
	G=computeG(0,T_2r,'Gaussian');
end

if (get(handles.Lorentzian,'Value') == get(handles.Lorentzian,'Max'))
    G=computeG(0,T_2r,'Lorentzian');
end

if (get(handles.SuperLorentzian,'Value') == get(handles.SuperLorentzian,'Max'))
    G=computeG(0,T_2r,'SuperLorentzian');
end

% Create parameter array and mask for fitting code
param_array = [F k_f T_1f T_2f];
mask = get(hObject,'UserData')';

% Set data arrays for fitting code
alphaData = get(handles.Alpha_table,'UserData');
if ~isempty(alphaData)
    alphas = alphaData(:,1)';
    fixTrf = alphaData(1,2);
    fixTR = alphaData(1,3);
    M_alpha = alphaData(:,4)';
else
    alphas = [];
    fixTrf = 0;
    fixTR = 0;
    M_alpha = [];
end

TrfData = get(handles.Trf_table,'UserData');
if ~isempty(TrfData)
    fixAlpha = TrfData(1,1);
    Trfs = TrfData(:,2)';
    TR_array = TrfData(:,3)';
    M_Trf = TrfData(:,4)';
else
    fixAlpha = 0;
    Trfs = [];
    TR_array = [];
    M_Trf = [];
end

% Fit for parameters
fittedParams = f_min_search(alphas, M_alpha, Trfs, M_Trf, TR_array, fixAlpha, fixTrf, fixTR, G, param_array, mask);

% Update parameters to fitted values 
F = fittedParams(1);
k_f = fittedParams(2);
T_1f = fittedParams(3);
T_2f = fittedParams(4);

% Set the values of parameters in corresponding fields
set(handles.F_num,'String',num2str(F));
set(handles.k_f_num,'String',num2str(k_f));
set(handles.T1f_num,'String',num2str(T_1f));
set(handles.T2f_num,'String',num2str(T_2f));
set(handles.F_slider,'Value',F);
set(handles.k_f_slider,'Value',k_f);
set(handles.T1f_slider,'Value',T_1f);
set(handles.T2f_slider,'Value',T_2f);

% Update plots with newly fitted curve
load('./FitTempData/arrays.mat');

if ~isempty(alphas)
    alphas_array(:, count, 1) = linspace(max(alphas)/60,max(alphas),60);
else
    alphas_array(:,count,1) = linspace(0,0,60);
end
if ~isempty(Trfs)
    Trfs_array(:,count, 1) = linspace(max(Trfs)/40,max(Trfs),40);
else
    Trfs_array(:,count,1) = linspace(0,0,40);
end

[alphas_array(:, count, 2), Trfs_array(:, count, 2)]=fitPlot(F,T_1f,T_2f,k_f,G,alphas,Trfs,TR_array,fixAlpha,fixTrf,fixTR);
tempLegend = strcat('F=',num2str(F),', k_{f}=',num2str(k_f),'s^{-1}, T_{1f}=',num2str(T_1f),'s, T_{2f}=',...
    num2str(T_2f),'s, T_{2r}=',num2str(T_2r),'s, G=',num2str(G),'s^{-1}');
legend_array = char(legend_array,tempLegend);
count=count+1;
save('./FitTempData/arrays.mat', 'count', 'Trfs_array', 'alphas_array','legend_array');

if ~isempty(alphaData)
plot(handles.alpha_plot, alphas, M_alpha, 'ob', alphas_array(:,:,1), alphas_array(:,:,2), '-');
xlabel(handles.alpha_plot, 'Flip angle (degree)','FontSize',9);
ylabel(handles.alpha_plot, '|M_{xy}| (normalized)','FontSize',9);
axis(handles.Trf_plot, [0 max(max(max(alphas_array(:,:,1))),max(alphas))*1.1 0 max(max(max(alphas_array(:,:,2))), max(M_alpha))*1.1]);
end

if ~isempty(TrfData)
plot(handles.Trf_plot, Trfs, M_Trf, 'ob', Trfs_array(:,:,1), Trfs_array(:,:,2),'-');
xlabel(handles.Trf_plot, 'T_{rf} (s)','FontSize',9);
ylabel(handles.Trf_plot, '|M_{xy}| (normalized)','FontSize',9);
axis(handles.Trf_plot, [0 max(max(max(Trfs_array(:,:,1))),max(Trfs))*1.1 0 max(max(max(Trfs_array(:,:,2))), max(M_Trf))*1.1]);
end

if (get(handles.legendOn,'Value') == get(handles.legendOn,'Max'))
h1 = legend(handles.alpha_plot,legend_array,'Location','South');
set(h1,'FontSize',9);
end

if get(handles.gridOn,'Value') == get(handles.gridOn,'Max')
    grid(handles.alpha_plot,'on');
    grid(handles.Trf_plot,'on');
end

guidata(hObject, handles);

%Y-Y

% --- Executes on button press in Reset_button.
function Reset_button_Callback(hObject, eventdata, handles)
% hObject    handle to Reset_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%Y-Y
% Resets everything: re-initialize all variables, wipe temporary files,
% clear tables and plots
alphas_array=[];
Trfs_array=[];
legend_array=[];
count=1;
save('./FitTempData/arrays.mat', 'count', 'Trfs_array', 'alphas_array','legend_array');
load('./Parameters/DefaultParams.mat');

set(handles.F_num,'String',num2str(F));
set(handles.k_f_num,'String',num2str(k_f));
set(handles.T1f_num,'String',num2str(T_1f));
set(handles.T2f_num,'String',num2str(T_2f));
set(handles.T2r_num,'String',num2str(T_2r));
set(handles.F_slider,'Value',F);
set(handles.k_f_slider,'Value',k_f);
set(handles.T1f_slider,'Value',T_1f);
set(handles.T2f_slider,'Value',T_2f);
set(handles.T2r_slider,'Value',T_2r);

set(handles.F_num,'Enable','off');
set(handles.k_f_num,'Enable','off');
set(handles.T1f_num,'Enable','off');
set(handles.T2f_num,'Enable','off');
set(handles.T2r_num,'Enable','off');
set(handles.F_slider,'Enable','off');
set(handles.k_f_slider,'Enable','off');
set(handles.T1f_slider,'Enable','off');
set(handles.T2f_slider,'Enable','off');
set(handles.T2r_slider,'Enable','off');

set(handles.F_checkbox,'Value',get(handles.F_checkbox,'Min'));
set(handles.k_f_checkbox,'Value',get(handles.k_f_checkbox,'Min'));
set(handles.T1f_checkbox,'Value',get(handles.T1f_checkbox,'Min'));
set(handles.T2f_checkbox,'Value',get(handles.T2f_checkbox,'Min'));

set(handles.Alpha_table,'Data',cell(1,5));
set(handles.Alpha_table,'ColumnFormat',{'numeric','numeric','numeric','numeric','logical'});
set(handles.Alpha_table,'ColumnEditable',[false false false false true]);
set(handles.Alpha_table,'UserData',[]);
set(handles.Trf_table,'Data',cell(1,5));
set(handles.Trf_table,'ColumnFormat',{'numeric','numeric','numeric','numeric','logical'});
set(handles.Trf_table,'ColumnEditable',[false false false false true]);
set(handles.Trf_table,'UserData',[]);

set(handles.Fit_button,'UserData',[0 0 0 0]');

set(handles.G_fixed_val,'String',num2str(G));
set(handles.fix_G,'Value',get(handles.fix_G,'Max'));
set(handles.Gaussian,'Value',get(handles.Gaussian,'Min'));
set(handles.Lorentzian,'Value',get(handles.Lorentzian,'Min'));
set(handles.SuperLorentzian,'Value',get(handles.SuperLorentzian,'Min'));

set(handles.legendOn,'Value',get(handles.legendOn,'Min'));
set(handles.gridOn,'Value',get(handles.gridOn,'Min'));


guidata(hObject, handles);


hold off
plot(handles.alpha_plot, 0, 0);
plot(handles.Trf_plot, 0, 0);

guidata(hObject, handles);
%Y-Y
