function varargout = sensitivity_gui(varargin)
% SENSITIVITY_GUI M-file for sensitivity_gui.fig
%      SENSITIVITY_GUI, by itself, creates a new SENSITIVITY_GUI or raises the existing
%      singleton*.
%
%      H = SENSITIVITY_GUI returns the handle to a new SENSITIVITY_GUI or the handle to
%      the existing singleton*.
%
%      SENSITIVITY_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SENSITIVITY_GUI.M with the given input arguments.
%
%      SENSITIVITY_GUI('Property','Value',...) creates a new SENSITIVITY_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before sensitivity_gui_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to sensitivity_gui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help sensitivity_gui

% Last Modified by GUIDE v2.5 24-Aug-2011 22:47:21

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @sensitivity_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @sensitivity_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before sensitivity_gui is made visible.
function sensitivity_gui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to sensitivity_gui (see VARARGIN)

% Choose default command line output for sensitivity_gui
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes sensitivity_gui wait for user response (see UIRESUME)
% uiwait(handles.figure1);

%Y-Y

% Initialize variables used across the GUI and save them in temporary files
% for later usage, load and set default values.
alphas_array=[];
Trfs_array=[];
legend_array=[];
count=1;
save('./SensitivityTempData/arrays.mat', 'count', 'Trfs_array', 'alphas_array','legend_array');
load('./Parameters/DefaultParams.mat');

set(handles.F_num,'String',num2str(F));
set(handles.k_f_num,'String',num2str(k_f));
set(handles.T1f_num,'String',num2str(T_1f));
set(handles.T2f_num,'String',num2str(T_2f));
set(handles.T2r_num,'String',num2str(T_2r));
set(handles.F_slider,'Value',F);
set(handles.k_f_slider,'Value',k_f);
set(handles.T1f_slider,'Value',T_1f);
set(handles.T2f_slider,'Value',T_2f);
set(handles.T2r_slider,'Value',T_2r);

set(handles.G_fixed_val,'String',num2str(G));
set(handles.fix_G,'Value',get(handles.fix_G,'Max'));
set(handles.Gaussian,'Value',get(handles.Gaussian,'Min'));
set(handles.Lorentzian,'Value',get(handles.Lorentzian,'Min'));
set(handles.SuperLorentzian,'Value',get(handles.SuperLorentzian,'Min'));

set(handles.legendOn,'Value',get(handles.legendOn,'Min'));
set(handles.gridOn,'Value',get(handles.gridOn,'Min'));


guidata(hObject, handles);
% Y-Y

%Y-Y

% --- Outputs from this function are returned to the command line.
function varargout = sensitivity_gui_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on slider movement.
function F_slider_Callback(hObject, eventdata, handles)
% hObject    handle to F_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

%Y-Y
% Sync the values of slider and box
temp=get(hObject,'Value');
set(handles.F_num,'String',num2str(temp));
guidata(hObject, handles);
%Y-Y

% --- Executes during object creation, after setting all properties.
function F_slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to F_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function k_f_slider_Callback(hObject, eventdata, handles)
% hObject    handle to text (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

%Y-Y
% Sync the values of slider and box
temp=get(hObject,'Value');
set(handles.k_f_num,'String',num2str(temp));
guidata(hObject, handles);
%Y-Y

% --- Executes during object creation, after setting all properties.
function k_f_slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to F_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

% --- Executes on slider movement.
function T1f_slider_Callback(hObject, eventdata, handles)
% hObject    handle to T1f_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

%Y-Y
% Sync the values of slider and box
temp=get(hObject,'Value');
set(handles.T1f_num,'String',num2str(temp));
guidata(hObject, handles);
%Y-Y

% --- Executes during object creation, after setting all properties.
function T1f_slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to T1f_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

% --- Executes on slider movement.
function T2f_slider_Callback(hObject, eventdata, handles)
% hObject    handle to text (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

%Y-Y
% Sync the values of slider and box
temp=get(hObject,'Value');
set(handles.T2f_num,'String',num2str(temp));
guidata(hObject, handles);
%Y-Y


% --- Executes during object creation, after setting all properties.
function T2f_slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

% --- Executes on slider movement.
function T2r_slider_Callback(hObject, eventdata, handles)
% hObject    handle to T2r_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

%Y-Y
% Sync the values of slider and box
temp=get(hObject,'Value');
set(handles.T2r_num,'String',num2str(temp));
guidata(hObject, handles);
%Y-Y

% --- Executes during object creation, after setting all properties.
function T2r_slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to T2r_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

function F_num_Callback(hObject, eventdata, handles)
% hObject    handle to F_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of F_num as text
%        str2double(get(hObject,'String')) returns contents of F_num as a double

%Y-Y
% Sync the values of slider and box
temp=min(str2num(get(hObject,'String')),0.2);
set(handles.F_slider,'Value',(temp));
set(handles.F_num,'String',num2str(temp));
guidata(hObject, handles);
%Y-Y

% --- Executes during object creation, after setting all properties.
function F_num_CreateFcn(hObject, eventdata, handles)
% hObject    handle to F_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function k_f_num_Callback(hObject, eventdata, handles)
% hObject    handle to k_f_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of k_f_num as text
%        str2double(get(hObject,'String')) returns contents of k_f_num as a double

%Y-Y
% Sync the values of slider and box
temp=min(str2num(get(hObject,'String')),20);
set(handles.k_f_slider,'Value',(temp));
set(handles.k_f_num,'String',num2str(temp));
guidata(hObject, handles);
%Y-Y

% --- Executes during object creation, after setting all properties.
function k_f_num_CreateFcn(hObject, eventdata, handles)
% hObject    handle to k_f_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function T1f_num_Callback(hObject, eventdata, handles)
% hObject    handle to T1f_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of T1f_num as text
%        str2double(get(hObject,'String')) returns contents of T1f_num as a double

%Y-Y
% Sync the values of slider and box
temp=min(str2num(get(hObject,'String')),10);
set(handles.T1f_slider,'Value',(temp));
set(handles.T1f_num,'String',num2str(temp));
guidata(hObject, handles);
%Y-Y

% --- Executes during object creation, after setting all properties.
function T1f_num_CreateFcn(hObject, eventdata, handles)
% hObject    handle to T1f_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function T2f_num_Callback(hObject, eventdata, handles)
% hObject    handle to T2f_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of T2f_num as text
%        str2double(get(hObject,'String')) returns contents of T2f_num as a double

%Y-Y
% Sync the values of slider and box
temp=min(str2num(get(hObject,'String')),0.1);
set(handles.T2f_slider,'Value',(temp));
set(handles.T2f_num,'String',num2str(temp));
guidata(hObject, handles);
%Y-Y


% --- Executes during object creation, after setting all properties.
function T2f_num_CreateFcn(hObject, eventdata, handles)
% hObject    handle to T2f_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function T2r_num_Callback(hObject, eventdata, handles)
% hObject    handle to T2r_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of T2r_num as text
%        str2double(get(hObject,'String')) returns contents of T2r_num as a double

%Y-Y
% Sync the values of slider and box
temp=min(str2num(get(hObject,'String')),0.0001);
set(handles.T2r_slider,'Value',(temp));
set(handles.T2r_num,'String',num2str(temp));
guidata(hObject, handles);
%Y-Y

% --- Executes during object creation, after setting all properties.
function T2r_num_CreateFcn(hObject, eventdata, handles)
% hObject    handle to T2r_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function G_fixed_val_Callback(hObject, eventdata, handles)
% hObject    handle to G_fixed_val (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of G_fixed_val as text
%        str2double(get(hObject,'String')) returns contents of G_fixed_val as a double


% --- Executes during object creation, after setting all properties.
function G_fixed_val_CreateFcn(hObject, eventdata, handles)
% hObject    handle to G_fixed_val (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes when selected object is changed in lineshape.
function lineshape_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in lineshape 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)

% Y-Y 
% Dummy function for button change to work properly.
lineshape=(get(hObject,'String'));
guidata(hObject, handles);
% Y-Y


% --- Executes on button press in legendOn.
function legendOn_Callback(hObject, eventdata, handles)
% hObject    handle to legendOn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of legendOn

% Y-Y

% show/hide legend

load('./SensitivityTempData/arrays.mat');
legend(handles.alpha_plot,'off');
if get(hObject,'Value') == get(hObject,'Max')
    h1 = legend(handles.alpha_plot,legend_array,'Location','South');
    set(h1,'FontSize',9);
end
guidata(hObject, handles);
% Y-Y



% --- Executes on button press in Load_Button.
function Load_Button_Callback(hObject, eventdata, handles)
% hObject    handle to Load_Button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Y-Y

% Load Parameters file defined by user, default parameters are loaded
% in case user fails to load right file, sets corresponding fields

load('./Parameters/DefaultParams.mat');
cd Parameters
uiload
cd ..

set(handles.F_num,'String',num2str(F));
set(handles.k_f_num,'String',num2str(k_f));
set(handles.T1f_num,'String',num2str(T_1f));
set(handles.T2f_num,'String',num2str(T_2f));
set(handles.T2r_num,'String',num2str(T_2r));
set(handles.F_slider,'Value',F);
set(handles.k_f_slider,'Value',k_f);
set(handles.T1f_slider,'Value',T_1f);
set(handles.T2f_slider,'Value',T_2f);
set(handles.T2r_slider,'Value',T_2r);

set(handles.legendOn,'Value',get(handles.legendOn,'Min'));

guidata(hObject, handles);
% Y-Y


% --- Executes on button press in Save_Button.
function Save_Button_Callback(hObject, eventdata, handles)
% hObject    handle to Save_Button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Y-Y

% Save current values of parameters into a .mat file
F=str2num(get(handles.F_num,'String'));
T_2f=str2num(get(handles.T2f_num,'String'));
k_f=str2num(get(handles.k_f_num,'String'));
T_1f=str2num(get(handles.T1f_num,'String'));
T_2r=str2num(get(handles.T2r_num,'String'));

uisave({'F','k_f','T_1f','T_2f','T_2r'},'./Parameters/LastSetParameters.mat');
guidata(hObject, handles);
% Y-Y

% --- Executes on button press in plot_graph.
function plot_graph_Callback(hObject, eventdata, handles)
% hObject    handle to plot_graph (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Y-Y
% Get current value of parameters from corresponding fields

F=str2num(get(handles.F_num,'String'));
T_2f=str2num(get(handles.T2f_num,'String'));
k_f=str2num(get(handles.k_f_num,'String'));
T_1f=str2num(get(handles.T1f_num,'String'));
T_2r=str2num(get(handles.T2r_num,'String'));
M_0f=1;

if (get(handles.fix_G,'Value') == get(handles.fix_G,'Max'))
	G=str2num(get(handles.G_fixed_val, 'String'));
end

if (get(handles.Gaussian,'Value') == get(handles.Gaussian,'Max'))
	G=computeG(0,T_2r,'Gaussian');
end

if (get(handles.Lorentzian,'Value') == get(handles.Lorentzian,'Max'))
    G=computeG(0,T_2r,'Lorentzian');
end

if (get(handles.SuperLorentzian,'Value') == get(handles.SuperLorentzian,'Max'))
    G=computeG(0,T_2r,'SuperLorentzian');
end

% Load temporary variable arrays
load('./SensitivityTempData/arrays.mat');

% Compute analytical solution for given set of parameters
[alphas_array(count, :), Trfs_array(count, :)]=SensitivityTest(F,T_1f,T_2f,k_f,G);

% Create legend entry for current set of parameters
tempLegend = strcat('F=',num2str(F),', k_{f}=',num2str(k_f),'s^{-1}, T_{1f}=',num2str(T_1f),'s, T_{2f}=',...
    num2str(T_2f),'s, T_{2r}=',num2str(T_2r),'s, G=',num2str(G),'s^{-1}');
if count ==1
    legend_array = tempLegend;
else
    legend_array = char(legend_array,tempLegend);
end

% Increment count and save data
count=count+1;
save('./SensitivityTempData/arrays.mat', 'count', 'Trfs_array', 'alphas_array','legend_array');

% Plot the varying flip angle curves
plot(handles.alpha_plot, 1:1:120, alphas_array);
xlabel(handles.alpha_plot,'Flip angle (degree)','FontSize',9);
ylabel(handles.alpha_plot,'|M_{xy}| (normalized)','FontSize',9);
axis(handles.alpha_plot,[0 120 0 max(max(alphas_array))*1.2]);

% Plot the varying Trf curves
plot(handles.Trf_plot, [0.5e-4:0.5e-4:2e-3], Trfs_array);
xlabel(handles.Trf_plot,'T_{rf} (s)','FontSize',9);
ylabel(handles.Trf_plot,'|M_{xy}| (normalized)','FontSize',9);
axis(handles.Trf_plot,[0 2e-3 0 max(max(Trfs_array))*1.2]);

% Show legend if legend on checkbox checked
if (get(handles.legendOn,'Value') == get(handles.legendOn,'Max'))
h1 = legend(handles.alpha_plot,legend_array,'Location','South');
set(h1,'FontSize',9);
end

if get(handles.gridOn,'Value') == get(handles.gridOn,'Max')
    grid(handles.alpha_plot,'on');
    grid(handles.Trf_plot,'on');
end

guidata(hObject, handles);

%Y-Y

% --- Executes on button press in clear_graph.
function clear_graph_Callback(hObject, eventdata, handles)
% hObject    handle to clear_graph (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%Y-Y

% Re-initialize variables, over-write files and clear plots
alphas_array=[];
Trfs_array=[];
legend_array=[];
count=1;
save('./SensitivityTempData/arrays.mat', 'count', 'Trfs_array', 'alphas_array','legend_array');
load('./SensitivityTempData/arrays.mat');

set(handles.legendOn,'Value',get(handles.legendOn,'Min'));
set(handles.gridOn,'Value',get(handles.gridOn,'Min'));

hold off
plot(handles.alpha_plot, 0, 0);
plot(handles.Trf_plot, 0, 0);
%Y-Y


% --- Executes on button press in gridOn.
function gridOn_Callback(hObject, eventdata, handles)
% hObject    handle to gridOn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of gridOn

% Y-Y
% show/hide grid
if get(hObject,'Value') == get(hObject,'Max')
    grid(handles.alpha_plot,'on');
    grid(handles.Trf_plot,'on');
else
    grid(handles.alpha_plot,'off');
    grid(handles.Trf_plot,'off');
end

guidata(hObject, handles);
% Y-Y
