function varargout = simulation_gui(varargin)
% SIMULATION_GUI M-file for simulation_gui.fig
%      SIMULATION_GUI, by itself, creates a new SIMULATION_GUI or raises the existing
%      singleton*.
%
%      H = SIMULATION_GUI returns the handle to a new SIMULATION_GUI or the handle to
%      the existing singleton*.
%
%      SIMULATION_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SIMULATION_GUI.M with the given input arguments.
%
%      SIMULATION_GUI('Property','Value',...) creates a new SIMULATION_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before simulation_gui_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to simulation_gui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help simulation_gui

% Last Modified by GUIDE v2.5 20-Aug-2011 17:18:03

% *****************************************
% GUI function to simulate On-resonance bSSFP sequence for qMT
% 
% Codes between %Y-Y tags are custom code, may be modified. Other codes are
% standard MATLAB code for GUI design
% 
% Ye Gu, Yaaseen Atchia, Ives Levesque, Nikola Stikov, 2011
% 
% *****************************************


% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @simulation_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @simulation_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before simulation_gui is made visible.
function simulation_gui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to simulation_gui (see VARARGIN)

% Choose default command line output for simulation_gui
handles.output = hObject;



% UIWAIT makes simulation_gui wait for user response (see UIRESUME)
% uiwait(handles.figure1);

% Y-Y
% Initializing variables used across the entire GUI, save them into .mat
% files for later usage
alphas_array=[];
Trfs_array=[];
TR_array=[];
fixAlpha = 0;
fixTrf = 0;
fixTR = 0;
count=1;
save('./SimTempData/VaryAlphaProt.mat', 'count', 'fixTrf', 'alphas_array','fixTR');
save('./SimTempData/VaryTrfProt.mat', 'count', 'Trfs_array', 'fixAlpha','TR_array');

% Load and set default values
load('./Parameters/DefaultParams.mat');
set(handles.F_num,'String',num2str(F));
set(handles.k_f_num,'String',num2str(k_f));
set(handles.T1f_num,'String',num2str(T_1f));
set(handles.T2f_num,'String',num2str(T_2f));
set(handles.T2r_num,'String',num2str(T_2r));
set(handles.F_slider,'Value',F);
set(handles.k_f_slider,'Value',k_f);
set(handles.T1f_slider,'Value',T_1f);
set(handles.T2f_slider,'Value',T_2f);
set(handles.T2r_slider,'Value',T_2r);
set(handles.G_fixed_val,'String',num2str(G));
set(handles.fix_G,'Value',get(handles.fix_G,'Max'));
set(handles.Gaussian,'Value',get(handles.Gaussian,'Min'));
set(handles.Lorentzian,'Value',get(handles.Lorentzian,'Min'));
set(handles.SuperLorentzian,'Value',get(handles.SuperLorentzian,'Min'));

% Update handles structure
guidata(hObject, handles);
%Y-Y

% --- Outputs from this function are returned to the command line.
function varargout = simulation_gui_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on slider movement.
function F_slider_Callback(hObject, eventdata, handles)
% hObject    handle to F_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

% Y-Y
% Sync the values of slider and box
temp=get(hObject,'Value');
set(handles.F_num,'String',num2str(temp));
guidata(hObject, handles);
% Y-Y

% --- Executes during object creation, after setting all properties.
function F_slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to F_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function k_f_slider_Callback(hObject, eventdata, handles)
% hObject    handle to text (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

%Y-Y
% Sync the values of slider and box
temp=get(hObject,'Value');
set(handles.k_f_num,'String',num2str(temp));
guidata(hObject, handles);
%Y-Y

% --- Executes during object creation, after setting all properties.
function k_f_slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to F_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function T2f_slider_Callback(hObject, eventdata, handles)
% hObject    handle to text (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

%Y-Y
% Sync the values of slider and box
temp=get(hObject,'Value');
set(handles.T2f_num,'String',num2str(temp));
guidata(hObject, handles);
%Y-Y


% --- Executes during object creation, after setting all properties.
function T2f_slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

% --- Executes on slider movement.
function T1f_slider_Callback(hObject, eventdata, handles)
% hObject    handle to T1f_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

%Y-Y
% Sync the values of slider and box
temp=get(hObject,'Value');
set(handles.T1f_num,'String',num2str(temp));
guidata(hObject, handles);
%Y-Y

% --- Executes during object creation, after setting all properties.
function T1f_slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to T1f_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

% --- Executes on slider movement.
function T2r_slider_Callback(hObject, eventdata, handles)
% hObject    handle to T2r_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

% Y-Y
% Sync the values of slider and box
temp=get(hObject,'Value');
set(handles.T2r_num,'String',num2str(temp));
guidata(hObject, handles);
% Y-Y

% --- Executes during object creation, after setting all properties.
function T2r_slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to T2r_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

function F_num_Callback(hObject, eventdata, handles)
% hObject    handle to F_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of F_num as text
%        str2double(get(hObject,'String')) returns contents of F_num as a double

% Y-Y
% Sync the values of slider and box
temp=min(str2num(get(hObject,'String')),0.2);
set(handles.F_slider,'Value',(temp));
set(handles.F_num,'String',num2str(temp));
guidata(hObject, handles);
% Y-Y

% --- Executes during object creation, after setting all properties.
function F_num_CreateFcn(hObject, eventdata, handles)
% hObject    handle to F_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function k_f_num_Callback(hObject, eventdata, handles)
% hObject    handle to k_f_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of k_f_num as text
%        str2double(get(hObject,'String')) returns contents of k_f_num as a double

% Y-Y
% Sync the values of slider and box
temp=min(str2num(get(hObject,'String')),20);
set(handles.k_f_slider,'Value',(temp));
set(handles.k_f_num,'String',num2str(temp));
guidata(hObject, handles);
% Y-Y

% --- Executes during object creation, after setting all properties.
function k_f_num_CreateFcn(hObject, eventdata, handles)
% hObject    handle to k_f_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function T2f_num_Callback(hObject, eventdata, handles)
% hObject    handle to T2f_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of T2f_num as text
%        str2double(get(hObject,'String')) returns contents of T2f_num as a double

% Y-Y
% Sync the values of slider and box
temp=min(str2num(get(hObject,'String')),0.1);
set(handles.T2f_slider,'Value',(temp));
set(handles.T2f_num,'String',num2str(temp));
guidata(hObject, handles);
% Y-Y


% --- Executes during object creation, after setting all properties.
function T2f_num_CreateFcn(hObject, eventdata, handles)
% hObject    handle to T2f_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function T1f_num_Callback(hObject, eventdata, handles)
% hObject    handle to T1f_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of T1f_num as text
%        str2double(get(hObject,'String')) returns contents of T1f_num as a double

% Y-Y
% Sync the values of slider and box
temp=min(str2num(get(hObject,'String')),10);
set(handles.T1f_slider,'Value',(temp));
set(handles.T1f_num,'String',num2str(temp));
guidata(hObject, handles);
% Y-Y

% --- Executes during object creation, after setting all properties.
function T1f_num_CreateFcn(hObject, eventdata, handles)
% hObject    handle to T1f_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function T2r_num_Callback(hObject, eventdata, handles)
% hObject    handle to T2r_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of T2r_num as text
%        str2double(get(hObject,'String')) returns contents of T2r_num as a double

% Y-Y
% Sync the values of slider and box
temp=min(str2num(get(hObject,'String')),0.0001);
set(handles.T2r_slider,'Value',(temp));
set(handles.T2r_num,'String',num2str(temp));
guidata(hObject, handles);
% Y-Y

% --- Executes during object creation, after setting all properties.
function T2r_num_CreateFcn(hObject, eventdata, handles)
% hObject    handle to T2r_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes when selected object is changed in lineshape.
function lineshape_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in lineshape 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)

function G_fixed_val_Callback(hObject, eventdata, handles)
% hObject    handle to G_fixed_val (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of G_fixed_val as text
%        str2double(get(hObject,'String')) returns contents of G_fixed_val as a double


% --- Executes during object creation, after setting all properties.
function G_fixed_val_CreateFcn(hObject, eventdata, handles)
% hObject    handle to G_fixed_val (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function FixTR_num_Callback(hObject, eventdata, handles)
% hObject    handle to FixTR_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of FixTR_num as text
%        str2double(get(hObject,'String')) returns contents of FixTR_num as a double

% Y-Y

% When enabled, sets the final value of TR to the value enter by user

set(handles.TR_num,'String',get(handles.FixTR_num,'String'));
guidata(hObject, handles);
% Y-Y

% --- Executes during object creation, after setting all properties.
function FixTR_num_CreateFcn(hObject, eventdata, handles)
% hObject    handle to FixTR_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function FixDiff_num_Callback(hObject, eventdata, handles)
% hObject    handle to FixDiff_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of FixDiff_num as text
%        str2double(get(hObject,'String')) returns contents of FixDiff_num as a double

% Y-Y

% When enabled, allows user to set the fixed value of the difference
% between TR and Trf, then calculates the value of TR for given Trf

set(handles.TR_num,'String',num2str(str2num(get(handles.FixDiff_num,'String'))+str2num(get(handles.Trf_num,'String'))));
guidata(hObject, handles);
% Y-Y

% --- Executes during object creation, after setting all properties.
function FixDiff_num_CreateFcn(hObject, eventdata, handles)
% hObject    handle to FixDiff_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes when selected object is changed in TRTypePanel.
function TRTypePanel_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in TRTypePanel 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)

% Y-Y

% enable/disable corresponding fields according to selected button

switch get(eventdata.NewValue,'Tag')
    case 'FixDiffButton'
        set(handles.FixTR_num,'Enable','off','String',[]);
        set(handles.FixDiff_num,'Enable','on','String',0);
        set(handles.TR_num,'String',num2str(str2num(get(handles.FixDiff_num,'String'))+str2num(get(handles.Trf_num,'String'))));
           
    case 'FixTRbutton'
        set(handles.FixDiff_num,'Enable','off','String',[]);
        set(handles.FixTR_num,'Enable','on','String',0);
        set(handles.TR_num,'String',get(handles.FixTR_num,'String'));
    
    otherwise
        error('something wrong with TR type');
end
        
guidata(hObject, handles);
% Y-Y


% --- Executes when selected object is changed in SimulationTypePanel.
function SimulationTypePanel_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in SimulationTypePanel 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)

% Y-Y

% Enable/disable corresponding fields according to button selection

switch get(eventdata.NewValue,'Tag')
    case 'FixAngleButton'
        set(handles.FixTrf_num,'Enable','off','String',[]);
        set(handles.FixAngle_num,'Enable','on','String',0);
        set(handles.FlipAngle_num,'Enable','off');
        set(handles.Trf_num,'Enable','on','String',0);
    
    case 'FixTrfButton'
        set(handles.FixAngle_num,'Enable','off','String',[]);
        set(handles.FixTrf_num,'Enable','on','String',0);
        set(handles.Trf_num,'Enable','off');
        set(handles.FlipAngle_num,'Enable','on','String',0);
    
    otherwise
        error('something wrong with simulation type');
end
guidata(hObject, handles);
% Y-Y

function FixAngle_num_Callback(hObject, eventdata, handles)
% hObject    handle to FixAngle_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of FixAngle_num as text
%        str2double(get(hObject,'String')) returns contents of FixAngle_num as a double

% Y-Y

% When enabled, sets the fixed value of flip angle (for varying Trfs
% protocols).

set(handles.FlipAngle_num,'String',get(handles.FixAngle_num,'String'));
guidata(hObject, handles);
% Y-Y


% --- Executes during object creation, after setting all properties.
function FixAngle_num_CreateFcn(hObject, eventdata, handles)
% hObject    handle to FixAngle_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function FixTrf_num_Callback(hObject, eventdata, handles)
% hObject    handle to FixTrf_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of FixTrf_num as text
%        str2double(get(hObject,'String')) returns contents of FixTrf_num
%        as a double


% Y-Y

% When enabled, allows user to set the fixed value of Trf (for varying flip angle
% protocols)

set(handles.Trf_num,'String',get(handles.FixTrf_num,'String'));
guidata(hObject, handles);
% Y-Y


% --- Executes during object creation, after setting all properties.
function FixTrf_num_CreateFcn(hObject, eventdata, handles)
% hObject    handle to FixTrf_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function Trf_num_Callback(hObject, eventdata, handles)
% hObject    handle to Trf_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Trf_num as text
%        str2double(get(hObject,'String')) returns contents of Trf_num as a double

% Y-Y

% When enabled, allow user to define Trf values for varying Trf protocols,
% then calculates corresponding TR values if TR varies with Trf with fixed
% difference.

if get(handles.FixDiffButton,'Value') == get(handles.FixDiffButton,'Max')
    set(handles.TR_num,'String',num2str(str2num(get(handles.FixDiff_num,'String'))+str2num(get(handles.Trf_num,'String'))));
end
guidata(hObject, handles);
% Y-Y

% --- Executes during object creation, after setting all properties.
function Trf_num_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Trf_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function FlipAngle_num_Callback(hObject, eventdata, handles)
% hObject    handle to FlipAngle_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of FlipAngle_num as text
%        str2double(get(hObject,'String')) returns contents of FlipAngle_num as a double

% Y-Y

% When enabled, allows user to set values of flip angle for varying flip
% angle protocols

% Does not affect other fields

% Y-Y


% --- Executes during object creation, after setting all properties.
function FlipAngle_num_CreateFcn(hObject, eventdata, handles)
% hObject    handle to FlipAngle_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in AddProt_button.
function AddProt_button_Callback(hObject, eventdata, handles)
% hObject    handle to AddProt_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Y-Y

% Add protocol to corresponding table, according to selection of simulation
% type buttons.
% The value of Flip angle, Trf and TR added are the values appearing in the
% numerical boxes at the moment "Add" button is pressed

% Add values to the varying Flip-angle (fix Trf) protocol with
% corresponding fixed values. Sets ALL Trf and TR values to the last set
% values. Save temporary protocol file for later usage by simulation button
if get(handles.FixTrfButton,'Value') == get(handles.FixTrfButton,'Max')
    load('./SimTempData/VaryAlphaProt.mat');
    alphas_array(count) = str2num(get(handles.FlipAngle_num,'String'));
    fixTrf = str2num(get(handles.Trf_num,'String'));
    fixTR = str2num(get(handles.TR_num,'String'));
    tableData(count,3) = 0;
    tableData(:,1) = alphas_array(:);
    tableData(:,2) = fixTrf;
    tableData(:,3) = fixTR;
    set(handles.VaryAlpha_table,'Data',tableData);
        
    count = count+1;
    save('./SimTempData/VaryAlphaProt.mat', 'count', 'fixTrf', 'alphas_array','fixTR');
end    
    
% Add values to the varying Trf (fix flip angle) protocol with
% corresponding fixed values. Sets ALL flip angle values to the last set
% value. Save temporary protocol file for later usage by simulation button
if get(handles.FixAngleButton,'Value') == get(handles.FixAngleButton,'Max') 
    load('./SimTempData/VaryTrfProt.mat');
    fixAlpha = str2num(get(handles.FlipAngle_num,'String'));
    Trfs_array(count) = str2num(get(handles.Trf_num,'String'));
    TR_array(count) = str2num(get(handles.TR_num,'String'));
    tableData(count,3) = 0;
    tableData(:,1) = fixAlpha;
    tableData(:,2) = Trfs_array(:);
    tableData(:,3) = TR_array(:);
    set(handles.VaryTrf_table,'Data',tableData);
    count = count+1;
    save('./SimTempData/VaryTrfProt.mat', 'count', 'Trfs_array', 'fixAlpha','TR_array');
end

guidata(hObject, handles);
% Y-Y



function TR_num_Callback(hObject, eventdata, handles)
% hObject    handle to TR_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of TR_num as text
%        str2double(get(hObject,'String')) returns contents of TR_num as a double

% Y-Y
% Display current value of TR set by other fields, disabled at all time,
% value always calculated from other fields
% Y-Y

% --- Executes during object creation, after setting all properties.
function TR_num_CreateFcn(hObject, eventdata, handles)
% hObject    handle to TR_num (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function PulseNum_slider_Callback(hObject, eventdata, handles)
% hObject    handle to PulseNum_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function PulseNum_slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to PulseNum_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function TimeRes_slider_Callback(hObject, eventdata, handles)
% hObject    handle to TimeRes_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function TimeRes_slider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to TimeRes_slider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on button press in ResetButton.
function ResetButton_Callback(hObject, eventdata, handles)
% hObject    handle to ResetButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


%Y-Y

% Re-initialize everything, basically the same as the initialization code
alphas_array=[];
Trfs_array=[];
TR_array=[];
fixAlpha = 0;
fixTrf = 0;
fixTR = 0;
count=1;
save('./SimTempData/VaryAlphaProt.mat', 'count', 'fixTrf', 'alphas_array','fixTR');
save('./SimTempData/VaryTrfProt.mat', 'count', 'Trfs_array', 'fixAlpha','TR_array');
load('./Parameters/DefaultParams.mat');
set(handles.F_num,'String',num2str(F));
set(handles.k_f_num,'String',num2str(k_f));
set(handles.T1f_num,'String',num2str(T_1f));
set(handles.T2f_num,'String',num2str(T_2f));
set(handles.T2r_num,'String',num2str(T_2r));
set(handles.F_slider,'Value',F);
set(handles.k_f_slider,'Value',k_f);
set(handles.T1f_slider,'Value',T_1f);
set(handles.T2f_slider,'Value',T_2f);
set(handles.T2r_slider,'Value',T_2r);
set(handles.G_fixed_val,'String',num2str(G));
set(handles.fix_G,'Value',get(handles.fix_G,'Max'));
set(handles.Gaussian,'Value',get(handles.Gaussian,'Min'));
set(handles.Lorentzian,'Value',get(handles.Lorentzian,'Min'));
set(handles.SuperLorentzian,'Value',get(handles.SuperLorentzian,'Min'));

clear tableData;
set(handles.VaryAlpha_table,'Data',[]);
set(handles.VaryTrf_table,'Data',[]);
set(handles.Status_text,'String','Simulation Status');

guidata(hObject, handles);
%Y-Y


% --- Executes on button press in Load_button.
function Load_button_Callback(hObject, eventdata, handles)
% hObject    handle to Load_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Y-Y

% Load Parameters file defined by user, default parameters are loaded
% in case user fails to load right file, sets corresponding fields
load('./Parameters/DefaultParams.mat');
cd Parameters
uiload
cd ..

set(handles.F_num,'String',num2str(F));
set(handles.k_f_num,'String',num2str(k_f));
set(handles.T1f_num,'String',num2str(T_1f));
set(handles.T2f_num,'String',num2str(T_2f));
set(handles.T2r_num,'String',num2str(T_2r));
set(handles.F_slider,'Value',F);
set(handles.k_f_slider,'Value',k_f);
set(handles.T1f_slider,'Value',T_1f);
set(handles.T2f_slider,'Value',T_2f);
set(handles.T2r_slider,'Value',T_2r);

guidata(hObject, handles);
% Y-Y

% --- Executes on button press in Simulate_button.
function Simulate_button_Callback(hObject, eventdata, handles)
% hObject    handle to Simulate_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Y-Y

% Start simulation according to set parameters and added protocols, save
% simulated results in appropriate folders

% Get current parameter values 
F=str2num(get(handles.F_num,'String'));
T_2f=str2num(get(handles.T2f_num,'String'));
k_f=str2num(get(handles.k_f_num,'String'));
T_1f=str2num(get(handles.T1f_num,'String'));
T_2r=str2num(get(handles.T2r_num,'String'));
M_0f=1;

if (get(handles.fix_G,'Value') == get(handles.fix_G,'Max'))
	G=str2num(get(handles.G_fixed_val, 'String'));
end

if (get(handles.Gaussian,'Value') == get(handles.Gaussian,'Max'))
	G=computeG(0,T_2r,'Gaussian');
end

if (get(handles.Lorentzian,'Value') == get(handles.Lorentzian,'Max'))
    G=computeG(0,T_2r,'Lorentzian');
end

if (get(handles.SuperLorentzian,'Value') == get(handles.SuperLorentzian,'Max'))
    G=computeG(0,T_2r,'SuperLorentzian');
end

% Save parameters as temporary .mat files for simulation code
% to load, this files are constantly overwritten 
save('./SimTempData/SimulationParams.mat','F','k_f','T_1f','T_2f','T_2r','M_0f','G');

% Load temporary protocol file, with varying flip angle protocol arrays
% saved earlier
load('./SimTempData/VaryAlphaProt.mat');


% Keep track of simulation progress (still buggy not displaying at the
% right time, probably because GUI does not update while simulation code is
% running
set(handles.Status_text,'String','Simulating....');
disp('Simulating...');

% Set time resolution and pulse number variables for simulation according
% to slider value
NumBin = 20*ceil(get(handles.TimeRes_slider,'Value'));
NumPulse = 50*ceil(get(handles.PulseNum_slider,'Value')/50);

% Create filenames for data files with time tag
alpha_filename = strcat('./SimulatedData/VaryingAlpha_',datestr(now,30),'.mat');
Trf_filename = strcat('./SimulatedData/VaryingTrf_',datestr(now,30),'.mat');
params_filename = strcat('./Parameters/SimParams_',datestr(now,30),'.mat');

% Simulate varying flip angle protocols
[alphas,M_alpha] = simAlpha(alphas_array,fixTR,fixTrf,NumPulse,NumBin);

% Update simulation status (buggy too)
set(handles.Status_text,'String','Simulating.... \n Varying Flip Angle DONE!');

% load temporary protocol array file with varying Trf protocols array saved
% earlier
load('./SimTempData/VaryTrfProt.mat');

% Simulate varying Trf protocols
[Trfs,M_Trf] = simTrf(fixAlpha,TR_array,Trfs_array,NumPulse,NumBin);

% Updata simulation status again (displays everything at the end);
set(handles.Status_text,'String','Simulating...... Varying Flip Angle DONE! ..... Varying Trf DONE!');

% Save simulated data files in the SimulatedData folder
save(alpha_filename,'alphas','M_alpha','fixTrf','fixTR');
save(Trf_filename,'Trfs','M_Trf','TR_array','fixAlpha');

% Save parameters used for this simulation in the Parameters folder, same
% time tag as the data files
save(params_filename,'F','k_f','T_1f','T_2f','T_2r','M_0f','G');

guidata(hObject, handles);
% Y-Y
